package com.paysafecard.merchant;

import java.util.ArrayList;
import java.util.HashMap;

public class Log {
	private static HashMap<String, ArrayList<HashMap<String, String>>> LogContainer = new HashMap<String, ArrayList<HashMap<String, String>>>();

	public static void addLogType(String type){
		ArrayList<HashMap<String, String>> varContainer = new ArrayList<HashMap<String, String>>();
		LogContainer.put(type, varContainer);
	}
	
	public static boolean doesLogTypeExist(String type){
		if(LogContainer.containsKey(type)){
			return true;
		}else{
			return false;
		}
	}
	
	public static void addLog(String msg, String call, String callParams, String result, String type){
		if(LogContainer.containsKey(type)){
			HashMap<String, String> currentLogContainerObject = new HashMap<String, String>();
			currentLogContainerObject.put("msg", msg);
			currentLogContainerObject.put("action", call);
			currentLogContainerObject.put("action_params", callParams);
			currentLogContainerObject.put("result", result);
			LogContainer.get(type).add(currentLogContainerObject);
		}
	}
	
	public static ArrayList<HashMap<String, String>> getLog(String type){
		if(LogContainer.containsKey(type) && LogContainer.get(type).size() > 0){
			return LogContainer.get(type);
		}else{
			return new ArrayList<HashMap<String, String>>(); 
		}
	}
	
	public static String getInfoLog(){
		if(LogContainer.containsKey("info") && LogContainer.get("info").size() > 0){
			return LogContainer.get("info").get(LogContainer.get("info").size()-1).get("msg");
		}else{
			return "";
		}
	}
}
